import atexit
import logging
import os

from rollbot import Rollbot
from command_system import RollbotMessage
from config import BOTS_LOOKUP, DB_FILE, get_config

try:
    os.remove(DB_FILE)
except FileNotFoundError:
    pass

import db

rollbot = Rollbot(
    plugins=get_config("plugins"),
    aliases=get_config("aliases"),
    responses=get_config("responses"),
    lookup=BOTS_LOOKUP,
    sleep_time=float(get_config("sleep_time")),
    callback=None,
    session_factory=db.session_scope
)
db.init_db()


def test_drive(msg, from_admin=True):
    rmsg = RollbotMessage("mock", None, None, "test_group", None, msg, from_admin)
    r =rollbot.run_command(rmsg)
    print(msg, ":", r.txt, ",", r.failure)


if __name__ == "__main__":
    [logging.disable(level) for level in [
        logging.DEBUG,
        logging.INFO,
        logging.WARN,
        logging.ERROR,
    ]]

    rollbot.start_plugins()
    atexit.register(rollbot.shutdown_plugins)

    [test_drive(msg) for msg in [
        "!session worst",
        "!session blah",
        "!session cancel",
        "!session next",
        "!session next asdf",
        "!session next Sunday",
        "!session late",
        "!session view",
        "!session cancel T e S t",
        "!session next Sunday",
        "!session late",
        "!session view",
        "!session cancel T e S t",
        "!session next Sunday",
        "!session late",
        "!session view",
        "!session cancel dIfFeReNt",
        "!session late",
        "!session cancel",
        "!session next Saturday",
        "!session next 01/01/1980",
        "!session next 01/01/2980",
        "!session late",
        "!session view",
        "!session cancel",
        "!session worst",
    ]]
